#include <stdio.h>

// Βοηθητική συνάρτηση για debugging που λειτουργεί
// αντί της printf με σκοπό αλλάζοντας μόνο τη μεταβλητή
// debug να μην εμφανίζονται τα μηνύματα κατά την
// εκτέλεση του κώδικα
void showMessage(char * message) {
    int debug = 0;
    if (debug == 1) {
        printf("%s\n", message);
    }
}

int main() {

    double a = 100;

    double c[100];

    showMessage("a1");	// είτε printf("a1");
    c[50] = 0;
    showMessage("a1b");	// είτε printf("a1b");
    c[5000] = 0;		// Αυτή η γραμμή είναι λάθος αφού
	// αναφέρεται στο στοιχείο στη θέση 5000 ενώ ο πίνακας
	// έχει μόνο 100 στοιχεία. Εδώ πιθανότατα το πρόγραμμα
	// "crashάρει"
    showMessage("a1bc");	// είτε printf("a1bc");
	
	// τα showMessage (ή τα printf) μας βοηθούν να εντοπίσουμε
	// το λάθος μας, αφού βλέπουμε ότι όταν το πρόγραμμα
	// κρασάρει έχουν εμφανιστεί μόνο τα δύο πρώτα μηνύματα
	// και όχι το 3ο, άρα το πρόβλημα είναι ανάμεσα στα
	// μηνύματα a1b και a1bc , δηλαδή στην c[5000] = 0;

    while(a >= 1) {
        printf("%lf\n", a);
        a = a / 2;
    }
    showMessage("a2");
    printf("TELIKA TO a EINAI : %lf\n", a);

    int i=1;

    while (i <= 10) {
        printf("%d ", i);
        i++;
    }
    printf("\ni: %d\n", i);

    for(i=1  ;  i <= 10  ;  i++) {
        printf("%d ", i);
    }
    printf("\ni: %d\n", i);

    for(a=100  ;   a>=1    ;  a /= 2) {
        printf("%lf\n", a);
    }
    printf("TELIKA TO a EINAI : %lf\n", a);


	// παραδείγματα τελεστών ανάθεσης
    a += 5;   a = a + 5
    a /= 2;   a = a / 2;
    double firstPersonHeight = 1;

    firstPersonHeight += 3;
    firstPersonHeight = firstPersonHeight + 3;

    return 0;
}
